/*
		ks.c
		Copyright (C) 1992,1994 fubuki
 */
#include  <stdio.h>
#include  <stdlib.h>
#include  <doslib.h>
#include  <unistd.h>
#include  <sys/stat.h>
#include  <string.h>
#include  <ctype.h>
#include  <jctype.h>

#define	TRUE	1
#define	FALSE	0
#define	isoct(n)	('0' <= n && '7' >= n)

char	*rcsid = "$Id: ks.c,v 1.5 1994-07-13 16:12:51+0900 kyoko Exp $";
char	*Name = "$Name: SleepingSummer $";

char	*pot;
int		exitcode = 0;

int lentbl[] = {
	712,
	32,	32, 32, 32, 32, 32, 32, 32, 32, 32,
	32,	32, 32, 32, 32, 32, 32, 32, 32, 32,
	6, 	6, 	6, 	6, 	6, 	6, 	6, 	6, 	6, 	6, 
	6, 	6
};

void
usage(void)
{
		char	*err = "function key set  1992,1994 fubuki\n"
					"Usage: ks #=string ...\n"
					"\tt@NVL[ #  string Zbg\n"
					"usage: ks <-l<file> | -s<file> | -r<file> | -w[file]> [-de]\n"
					"\t-l<file> key.sys t@C̃[h\n"
					"\t-s<file> key.sys t@C̃Z[u\n"
					"\t-r<file> ks text t@C̃[h\n"
					"\t-w[file] ks text t@C̃Cg\n"
					"\t-d       t@NVGA\\n"
					"\t-e       t@NVGA\n"
					"Escape Character:\n"
					"\t\\OCT \\xHEX \\r \\n \\t \\a \\e ^CHAR\n"
					"Other Number:\n"
					"\t21 ROLL UP    25 UP     29 CLEAR\n"
					"\t22 ROLL DOWN  26 LEFT   30 HELP\n"
					"\t23 INSERT     27 RIGHT  31 HOME\n"
					"\t24 DELETE     28 DOWN   32 UNDO\n"
		;
	fwrite(err, strlen(err), 1, stderr);
	exit(1);
	/* NOTREACHED */
}

void
potset(int n, char *str)
{
	int		i, offset;

	for(offset = 0, i = 1; i < n; i++)
		offset += lentbl[i];
	memcpy(pot+offset, str, lentbl[n]);
}

int
mul(int a, int b)
{
	int	n = 0;
	while(b--) {
		n += a;
	}
	return n;
}

int									/* 8i𐔒lɕϊ */
o2i(char *p)
{
	int		seed;
	int		r;
	int		l;

	l = strlen(p);
	p = &p[l-1];
	r = 0;
	seed = 1;
	while(l--) {
		r += mul(*p - '0', seed);
		seed <<= 3;
		p--;
	}
	return r;
}

int									/* 16i𐔒lɕϊ */
h2i(char *p)
{
	int		seed;
	int		r;
	int		l;

	l = strlen(p);
	p = &p[l-1];
	r = 0;
	seed = 1;
	while(l--) {
		*p = toupper(*p);
		if (isdigit(*p))
			r += mul(*p - '0', seed);
		else
			r += mul(*p - 'A'+10, seed);
/*		printf("*%c (%x)\n", *p, r); */
		seed <<= 4;
		p--;
	}
	return r;
}

char *
i2a(int v, int r, int l)
{
	static char	buffer[32];
	static char	buffer2[32], *p;
	int			i;

	itoa(v, buffer, r);
	p = buffer2;
	for(i = strlen(buffer); i < l; i++)
		*p++ = '0';
	*p = '\0';
	strcat(buffer2, buffer);
	return (char *)buffer2;
}

void
fkeyset(int n, char *arg)
{
	int		i, j;
	int		l = FALSE;
	char	temp[512], *p;
	char	temp2[256], *q;

	p = temp;
	for(i = 0; i < (lentbl[n] - 1) && '\0' != *arg; i++) {
		if (iskanji(*arg)) {
			*p++ = *arg++;
			*p++ = *arg++;
			if(i == lentbl[n] - 2) l = TRUE;
			i++;
		}
		else {
			switch(*arg) {

			case	'^':
				arg++;
				*p++ = (toupper(*arg++) - '@') & 0x7f;
				break;
			case	'\\':
				arg++;
				switch(*arg) {
					case	'0':	/* 8i */
					case	'1':
					case	'2':
					case	'3':
					case	'4':
					case	'5':
					case	'6':
					case	'7':
						q = temp2;
						j = 3;		/* 3P^܂ */
						while(j-- && isoct(*arg)) *q++ = *arg++;
						*q = '\0';
						*p++ = o2i(temp2);
						break;
					case	'x':		/* 16i */
						arg++;
						q = temp2;
						j = 2;		/* 2P^܂ */
						while(j-- && (isdigit(*arg) ||
								('A' <= toupper(*arg) && 'F' >= toupper(*arg))))
							*q++ = toupper(*arg++);
						*q = '\0';
						*p++ = h2i(temp2);
						break;
					case	'r':
						arg++;
						*p++ = '\x0d';
						break;
					case	'n':
						arg++;
						*p++ = '\x0a';
						break;
					case	't':
						arg++;
						*p++ = '\x09';
						break;
					case	'a':
						arg++;
						*p++ = '\x07';
						break;
					case	'e':
						arg++;
						*p++ = '\x1b';
						break;
					default:
						*p++ = *arg++;
				}
				break;
			default:
				*p++ = *arg++;

			}
		}
	}
	for(; i < (lentbl[n] - 1); i++) *p++ = '\0';
	if (iskanji(temp[lentbl[n]-2]) && iskanji2(temp[lentbl[n]-1]))	/* Ȃ񂩃_[eB[ */
		temp[lentbl[n]-2] = '\0';
	temp[lentbl[n]-1] = '\0';
	if ('\0' != *arg || TRUE == l) {
		fputs("ks: 񂪒߂܂: function ", stderr);	/* string too long */
		fputs(i2a(n, 10, 2), stderr);
		fputc('\n', stderr);
		exitcode = 2;
	}
/*	printf("%2d -> %s\n", n, temp); */
	potset(n, temp);
}

void
readfunc(char *name)
{
	FILE	*fp;
	char	buffer[1024], *p;
	char	temp[64], *q;
	int		n, qrt;

	if (NULL == (fp = fopen(name, "r"))) {
		fprintf(stderr, "ks: t@CI[vł܂: %s\n", name);
		exit(1);
		/* NOTREACHED */
	}
	while(fgets(buffer, 1024, fp)) {
		p = buffer;
		if ('#' == *p) continue;
		while('\n' != *p && '\0' != *p) {
			while(isspace(*p)) p++;
			if (!isdigit(*p)) goto bads;
			q = temp;
			while(isdigit(*p)) *q++ = *p++;
			*q = '\0';
			n = atoi(temp);
			if (!isspace(*p) && ',' != *p && '=' != *p) goto bads;
			while(isspace(*p)||',' == *p||'=' == *p) p++;
			qrt = 0;
			q = temp;
			if ('\"' == *p || '\'' == *p) {
				qrt = *p;
				p++;
				while(qrt != *p) *q++ = *p++;
				p++;
			}
			else
				while(!isspace(*p)) *q++ = *p++;
			while(isspace(*p)) p++;
			*q = '\0';
			fkeyset(n, temp);
		}
	}
	fclose(fp);
	return;

	bads: {
		fputs("ks: t@CtH[}bg\n", stderr);
		exit(1);
		/* NOTREACHED */
	}
}

void
loadfunc(char *name)
{
	FILE	*fp;
	char	*buffer = pot;
	struct stat	stbuff;

	if (-1 == stat(name, &stbuff)) {
		fprintf(stderr, "ks: t@C܂: %s\n", name);
		exit(1);
		/* NOTREACHED */
	}
	if (712 != stbuff.st_size) {
		readfunc(name);
		return;
	}

	fp = fopen(name, "rb");
	fread(buffer, 712, 1, fp);
	fclose(fp);
}

void
savefunc(char *name)
{
	char	*buffer = pot;
	FILE	*fp;

	unlink(name);
	if (NULL == (fp = fopen(name, "wb"))) {
		fprintf(stderr, "ks: t@CI[vł܂: %s\n", name);
		exit(1);
		/* NOTREACHED */
	}
	if (1 != fwrite(buffer, 712, 1, fp)) {
		fprintf(stderr, "ks: t@C݂ł܂: %s\n", name);
		exit(1);
		/* NOTREACHED */
	}
	if (EOF == fclose(fp)) {
		fprintf(stderr, "ks: t@CN[Ył܂: %s\n", name);
		exit(1);
		/* NOTREACHED */
	}
}

char *
b2s(char *p)
{
	char	*q = p;

	while(*q) {
		if (iskanji(*q)) {
			q += 2;
			continue;
		}
		else if ('\\' == *q)
			*q = '/';
		else
			*q = *q;
		q++;
	}
	return p;
}

void
writefunc(char *name)
{
	unsigned char	*buffer = (unsigned char*)pot;
	char			*program = "ks";
	FILE			*fp;
	int				n, i;

/*	program = b2s((char *)get_traditional_argv0());
	unlink(name);
*/
	if (NULL == name) fp = stdout;
	else if (NULL == (fp = fopen(name, "w"))) {
		fprintf(stderr, "ks: t@CI[vł܂: %s\n", name);
		exit(1);
		/* NOTREACHED */
	}

	fprintf(fp, "#! %s -r\n\n", program);	/*  for  fish or execd  */

	for (n = 1; n < 32+1; n++) {
		fputs(i2a(n, 10, 2), fp);
		fputs("=\'", fp);
		for(i = 0; i < lentbl[n] && '\0' != *buffer; i++, buffer++) {
			if (iskanji(*buffer)) {
				fputc(*buffer, fp);
				fputc(*(buffer+1), fp);
				i++;
				buffer++;
			}
			else if ('\"' == *buffer || '\'' == *buffer ||
				'\\' == *buffer || '^'  == *buffer || !isprint(*buffer)) {
				fputc('\\', fp);
				fputs(i2a(*buffer, 8, 3), fp);
			}
			else
				fputc(*buffer, fp);
		}
		for (; i < lentbl[n]; i++) buffer++;
		fputs("\'\n", fp);
	}
	if (EOF == fclose(fp)) {
		fprintf(stderr, "ks: t@CN[Ył܂: %s\n", name);
		exit(1);
		/* NOTREACHED */
	}
}

void
keyset(int argc, char **argv)
{
	int		i, n;
	char	temp[512], *p, *q;

	for(i = 1; argc > i; i ++) {
		q = argv[i];
		if ('-' == *q) {
			while(*++q) {
				switch(*q) {
					case	'V':
						printf("version: %s\n", Name);
						exit(0);
						/* NOTREACHED */
					case	'l':
						if ('\0' == *++q) {
							if (argc <= ++i) usage();
							q = argv[i];
						}
						loadfunc(q);
						goto BREAK;
					case	'r':
						if ('\0' == *++q) {
							if (argc <= ++i) usage();
							q = argv[i];
						}
						readfunc(q);
						goto BREAK;
					case	's':
						if ('\0' == *++q) {
							if (argc <= ++i) usage();
							q = argv[i];
						}
						savefunc(q);
						goto BREAK;
					case	'w':
						if ('\0' == *++q) {
							if (argc <= ++i) q = NULL;
							else 			 q = argv[i];
						}
						writefunc(q);
						goto BREAK;
					case	'e':
						_dos_c_cls_al();
						_dos_c_fnkmod(2);
						_dos_c_window(0, 31);
						break;
					case	'd':
						_dos_c_cls_al();
						_dos_c_fnkmod(0);
						_dos_c_window(0, 31);
						break;
					default:
						usage();
						/* NOTREACHED */
				}
			}
			BREAK:;
		}
		else if (isdigit(*q)) {
			p = temp;
			while(',' != *q && '=' != *q && '\0' != *q)
				*p++ = *q++;
			*p = '\0';
			if (1 > (n = atoi(temp)) || 32 < n) {
				fprintf(stderr, "ks: L[ԍ: %s\n", argv[i]);
				exit(1);
				/* NOTREACHED */
			}
			fkeyset(n, ++q);
		}
		else {
			fprintf(stderr, "ks: L[ԍ: %s\n", argv[i]);
			exit(1);
			/* NOTREACHED */
		}
	}
}

int
main(int argc, char **argv)
{
	if (1 == argc) usage();
	if (NULL == (pot = malloc(712))) {
		fputs("ks: ܂\n", stderr);
		exit(1);
		/* NOTREACHED */
	}
	_dos_fnckeygt(0, pot);
	keyset(argc, argv);
	_dos_fnckeyst(0, pot);
	free(pot);
	return exitcode;
}

/*** end of ks.c ***/
